aboutsummaryrefslogtreecommitdiff
path: root/qa/pull-tester/run-bitcoind-for-test.sh.in
diff options
context:
space:
mode:
authorCory Fields <theuni-nospam-@xbmc.org>2013-05-27 19:55:01 -0400
committerCory Fields <theuni-nospam-@xbmc.org>2013-09-05 21:31:03 -0400
commit35b8af92265ed74de63c3818e5290c27b3f35df2 (patch)
tree7cd074e2ba31ca9346d69922e312ebd3e7298711 /qa/pull-tester/run-bitcoind-for-test.sh.in
parent2fee100f036626866e5dca3f27b7562da25e43f3 (diff)
downloadbitcoin-35b8af92265ed74de63c3818e5290c27b3f35df2.tar.xz
autotools: switch to autotools buildsystem
Diffstat (limited to 'qa/pull-tester/run-bitcoind-for-test.sh.in')
-rwxr-xr-xqa/pull-tester/run-bitcoind-for-test.sh.in27
1 files changed, 27 insertions, 0 deletions
diff --git a/qa/pull-tester/run-bitcoind-for-test.sh.in b/qa/pull-tester/run-bitcoind-for-test.sh.in
new file mode 100755
index 0000000000..e02fef3b56
--- /dev/null
+++ b/qa/pull-tester/run-bitcoind-for-test.sh.in
@@ -0,0 +1,27 @@
+#!/bin/bash
+DATADIR="@abs_top_builddir@/.bitcoin"
+rm -rf "$DATADIR"
+mkdir -p "$DATADIR"/regtest
+touch "$DATADIR/regtest/debug.log"
+tail -q -n 1 -F "$DATADIR/regtest/debug.log" | grep -m 1 -q "Done loading" &
+WAITER=$!
+"@abs_top_builddir@/src/bitcoind@EXEEXT@" -connect=0.0.0.0 -datadir="$DATADIR" -rpcuser=user -rpcpassword=pass -listen -keypool=3 -debug -logtimestamps -port=18444 -regtest &
+BITCOIND=$!
+
+#Install a watchdog.
+(sleep 10 && kill -0 $WAITER 2>/dev/null && kill -9 $BITCOIND $$)&
+wait $WAITER
+
+if [ -n "$TIMEOUT" ]; then
+ timeout "$TIMEOUT"s "$@"
+ RETURN=$?
+else
+ "$@"
+ RETURN=$?
+fi
+
+(sleep 15 && kill -0 $BITCOIND 2>/dev/null && kill -9 $BITCOIND $$)&
+kill $BITCOIND && wait $BITCOIND
+
+# timeout returns 124 on timeout, otherwise the return value of the child
+exit $RETURN